Summary:			PW3270 D-Bus service
Name:				pw3270d
Version:			5.1
Release:			0
License:			GPL-2.0
Source:			%{name}-%{version}.tar.bz2
URL:				https://softwarepublico.gov.br/gitlab/pw3270/pw3270d
Group:			System

BuildRoot:		/var/tmp/%{name}-%{version}

BuildRequires:		autoconf >= 2.61
BuildRequires:		automake
BuildRequires:		binutils
BuildRequires:		coreutils
BuildRequires:		gcc
BuildRequires:		m4
BuildRequires:		pkgconfig
BuildRequires:		pkgconfig(lib3270) >= 5.1
BuildRequires:		pkgconfig(glib-2.0)
BuildRequires:		pkgconfig(dbus-1)
BuildRequires:		pkgconfig(dbus-glib-1)
BuildRequires:		pkgconfig(systemd)
BuildRequires:		fdupes
BuildRequires:		systemd-devel

Requires:			dbus-1
Requires(post):		psmisc
Requires(postun):	psmisc

%{systemd_requires}

%description

Non GUI D-Bus service for screen scraping scripts using pw3270 modules.

%prep

%setup

export CFLAGS="$RPM_OPT_FLAGS"
export CXXFLAGS="$RPM_OPT_FLAGS"
export FFLAGS="$RPM_OPT_FLAGS"

aclocal
autoconf
%configure

%build
make clean
make Release

%install
rm -rf $RPM_BUILD_ROOT

%makeinstall

%fdupes $RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%{_sbindir}/pw3270d
%{_unitdir}/pw3270d.service
%config /etc/dbus-1/system.d/pw3270d.conf
/usr/share/dbus-1/system-services/br.com.bb.pw3270.service.service

%preun
%service_del_preun pw3270d.service
exit 0

%pre
%service_add_pre pw3270d.service
exit 0

%post
%service_add_post pw3270d.service
/usr/bin/killall --quiet -HUP dbus-daemon || :
%{systemd_post}
exit 0

%postun
%service_del_postun pw3270d.service
/usr/bin/killall --quiet -HUP dbus-daemon || :
%{systemd_postun_with_restart} 
exit 0

%changelog

